function price = AmPutLattice(S0,K,r,T,sigma,N)
% Precompute invariant quantities
deltaT = T/N;
u=exp(sigma * sqrt(deltaT));
d=1/u;
p=(exp(r*deltaT) - d)/(u-d);
discount = exp(-r*deltaT);
p_u = discount*p;
p_d = discount*(1-p);
% set up S values
SVals = zeros(2*N+1,1);
SVals(N+1) = S0;
for i=1:N
    SVals(N+1+i) = u*SVals(N+i);
    SVals(N+1-i) = d*SVals(N+2-i);
end
% set up terminal values
PVals = zeros(2*N+1,1);
for i=1:2:2*N+1
    PVals(i) = max(K-SVals(i),0);
end
% work backwards
for tau=1:N
    for i= (tau+1):2:(2*N+1-tau)
        %%%%%%%%%%%% your task is described here %%%%%%%%%%%%
        % assign the value hold to how much you get in case you
        % continue holding the asset
        % (be careful, we are using the more efficient lattice here)
        
        % now calculate the value of the Put option as a maximum of 
        % 1) holding the option and getting hold
        % 2) or exercising the option and getting (K - S_t)
        
        %%%%%%%%%%%% the end of your task %%%%%%%%%%%%%%%%%%%
    end
end
price = PVals(N+1);
