function [p,ci] = ExchangeMC(V0,U0,sigmaV,sigmaU,rho,T,r,NRepl)

%%%%%%%%%%%% your task is described here %%%%%%%%%%%%
% generate two correlated series of normally distributed
% Wiener increments
% call them eps1 and eps2

%%%%%%%%%%%% the end of your task %%%%%%%%%%%%%%%%%%%


VT = V0*exp((r - 0.5*sigmaV^2)*T + sigmaV*sqrt(T)*eps1);
UT = U0*exp((r - 0.5*sigmaU^2)*T + sigmaU*sqrt(T)*eps2);
DiscPayoff = exp(-r*T)*max(VT-UT, 0);
[p,s,ci] = normfit(DiscPayoff);
