%% Day5 - Practice session
%
% 1) American Put Option using Lattice
% 2) Exchange Option using Monte Carlo
% 3) Pricing Vanilla European Option using Explicit Method

%%
%
% Pricing an American Put Option using Binomial Lattice

%%%%%%%%%%%% your task is described here %%%%%%%%%%%%
% go inside the EuPutExpl.m .....
% assign the value hold to how much you get in case you
% continue holding the asset
% (be careful, we are using the more efficient lattice here)

% now calculate the value of the Put option as a maximum of 
% 1) holding the option and getting hold
% 2) or exercising the option and getting (K - S_t)

%%%%%%%%%%%% the end of your task %%%%%%%%%%%%%%%%%%%

S0 = 50;
K  = 50;
r = 0.1;
T = 5/12;
sigma = 0.4;
N = 1000;

[americanPut] = AmPutLattice(S0,K,r,T,sigma,N);

disp(['The price of the exchange option is ',num2str(americanPut),'$'])
%You should get 4.2836

%% 
%
% Pricing an Exchange Option using Monte Carlo

%%%%%%%%%%%% your task is described here %%%%%%%%%%%%
% go inside the ExchangeMC.m function .....
% generate two correlated series of normally distributed
% Wiener increments
% call them eps1 and eps2

%%%%%%%%%%%% the end of your task %%%%%%%%%%%%%%%%%%%

V0 = 40;
U0 = 50;
sigmaV = 0.3;
sigmaU = 0.7;
rho = -0.6;
r = 0.1;
T = 5/12;
NRepl = 10000;

[exchangePrice,ci] = ExchangeMC(V0,U0,sigmaV,sigmaU,rho,T,r,NRepl);

disp(['The price of the exchange option is ',num2str(exchangePrice),'$'])
%You should get 6.0493

%% 
%
% Pricing Vanilla European Option using Explicit Method

%%%%%%%%%%%% your task is described here %%%%%%%%%%%%
% go inside the EuPutExpl.m function .....
% inside the double loop
% assign the correct value to f_{i,j} (in this case f is matval)

%%%%%%%%%%%% the end of your task %%%%%%%%%%%%%%%%%%%

S0 = 50;
K  = 50;
r = 0.1;
T = 5/12;
sigma = 0.3;
Smax = 100;
dS = 1.5;
dt = 5/1200;

[euPutPrice] = EuPutExpl(S0,K,r,T,sigma,Smax,dS,dt);

disp(['The price of the European Put option is ',num2str(euPutPrice),'$'])
% You should get 2.8597$

dS = 1;
[euPutPrice2] = EuPutExpl(S0,K,r,T,sigma,Smax,dS,dt);

disp(['The price of the European Put option is ',num2str(euPutPrice2),'$'])
% numerical instability that we discussed